﻿define(["dojo/_base/declare", "esri/layers/tiled"], function (declare) {
    return declare(esri.layers.TiledMapServiceLayer, {
        vecOrImg: "vector",//矢量或影像
        mapOrAnno: "map",//地图或注记
        constructor: function (vecOrImg, mapOrAnno) {
            this.vecOrImg = vecOrImg || this.vecOrImg;
            this.mapOrAnno = mapOrAnno || this.mapOrAnno;

            this.spatialReference = new esri.SpatialReference({ wkid: 4326 });
            //this.initialExtent = (this.fullExtent = new esri.geometry.Extent(-180.0, -90.0, 180.0, 90.0, this.spatialReference));
            //this.initialExtent = (this.fullExtent = new esri.geometry.Extent(73.328, 13.041, 135.204, 46.835, this.spatialReference));
            this.initialExtent = new esri.geometry.Extent(73.328, 13.041, 135.204, 46.835, this.spatialReference);
            this.fullExtent = new esri.geometry.Extent(-180.0, -90.0, 180.0, 90.0, this.spatialReference);

            this.tileInfo = new esri.layers.TileInfo({
                "dpi": 96,    
                "rows": 256,
                "cols": 256,
                "compressionQuality": 0,
                "origin": {
                    "x": -180,
                    "y": 90
                },
                "spatialReference": {
                    "wkid": 4326
                },
                "lods": [
	              { "level": 1, "resolution": 0.7031249999891485, "scale": 2.958293554545656E8 },
	              { "level": 2, "resolution": 0.35156249999999994, "scale": 1.479146777272828E8 },
	              { "level": 3, "resolution": 0.17578124999999997, "scale": 7.39573388636414E7 },
	              { "level": 4, "resolution": 0.08789062500000014, "scale": 3.69786694318207E7 },
	              { "level": 5, "resolution": 0.04394531250000007, "scale": 1.848933471591035E7 },
	              { "level": 6, "resolution": 0.021972656250000007, "scale": 9244667.357955175 },
	              { "level": 7, "resolution": 0.01098632812500002, "scale": 4622333.678977588 },
	              { "level": 8, "resolution": 0.00549316406250001, "scale": 2311166.839488794 },
	              { "level": 9, "resolution": 0.0027465820312500017, "scale": 1155583.419744397 },
	              { "level": 10, "resolution": 0.0013732910156250009, "scale": 577791.7098721985 },
	              { "level": 11, "resolution": 0.000686645507812499, "scale": 288895.85493609926 },
	              { "level": 12, "resolution": 0.0003433227539062495, "scale": 144447.92746804963 },
	              { "level": 13, "resolution": 0.00017166137695312503, "scale": 72223.96373402482 },
	              { "level": 14, "resolution": 0.00008583068847656251, "scale": 36111.98186701241 },
	              { "level": 15, "resolution": 4.291534503880557e-005, "scale": 18035.742100270665 },
	              { "level": 16, "resolution": 2.1457672519402785e-005, "scale": 9017.8710501353326 },
	              { "level": 17, "resolution": 1.0728836259701392e-005, "scale": 4508.9355250676663 },
	              { "level": 18, "resolution": 5.36441802978515625e-006, "scale": 2254.4677625338331 },
	              { "level": 19, "resolution": 2.682209014892578125e-006, "scale": 1127.2338812669166 },
	              { "level": 20, "resolution": 1.3411045074462890625e-006, "scale": 563.61694063345828 }

                ]
            });

            this.loaded = true;
            this.onLoad(this);
        },

        getTileUrl: function (level, row, col) {

            var imageUrl = "";
            if (this.vecOrImg == "vector") {
                if (this.mapOrAnno == "map") {

                    imageUrl = "http://t" + col % 8 + ".tianditu.com/vec_c/wmts?SERVICE=WMTS&REQUEST=GetTile&VERSION=1.0.0&LAYER=vec&STYLE=default&TILEMATRIXSET=c&TILEMATRIX=" + level + "&TILEROW=" + row + "&TILECOL=" + col + "&FORMAT=tiles&tk=b24f842759c479d657913702c3684369";

                } else if (this.mapOrAnno == "anno") {
                
                    imageUrl = "http://t" + row % 8 + ".tianditu.com/cva_c/wmts?SERVICE=WMTS&REQUEST=GetTile&VERSION=1.0.0&LAYER=cva&STYLE=default&TILEMATRIXSET=c&TILEMATRIX=" + level + "&TILEROW=" + row + "&TILECOL=" + col + "&FORMAT=tiles&tk=b24f842759c479d657913702c3684369";
                    
                }
               
            } else if (this.vecOrImg == "imagery") {
                if (this.mapOrAnno == "map") {

                    imageUrl = "http://t" + col % 8 + ".tianditu.com/img_c/wmts?SERVICE=WMTS&REQUEST=GetTile&VERSION=1.0.0&LAYER=img&STYLE=default&TILEMATRIXSET=c&TILEMATRIX=" + level + "&TILEROW=" + row + "&TILECOL=" + col + "&FORMAT=tiles&tk=b24f842759c479d657913702c3684369";

                } else if (this.mapOrAnno == "anno") {

                    imageUrl = "http://t" + row % 8 + ".tianditu.com/cia_c/wmts?SERVICE=WMTS&REQUEST=GetTile&VERSION=1.0.0&LAYER=cia&STYLE=default&TILEMATRIXSET=c&TILEMATRIX=" + level + "&TILEROW=" + row + "&TILECOL=" + col + "&FORMAT=tiles&tk=b24f842759c479d657913702c3684369";

                }
               
            }
            return imageUrl;
        }
    });
});