﻿define(["app/core/application", "dojo/_base/lang", "dojo/dom", "dojo/on", "esri/tasks/IdentifyTask",
    "esri/tasks/IdentifyParameters", "esri/layers/ArcGISDynamicMapServiceLayer"],
    function (application, lang, dom, on, IdentifyTask, IdentifyParameters, ArcGISDynamicMapServiceLayer) {

        // module:
        //      app/func/identify

        // summary:
        //      识别查询

        // description:
        //      暂无描述

        var func = {

            // -----公有字段（小驼峰）-----
            // 暂无

            // -----私有字段（下划线开头 + 小驼峰）-----
            // 暂无

            // -----override或自动调用方法-----
            // 初始化方法
            init: function () {

            },

            // -----公有方法（小驼峰）-----
            activate: function () {
                var map = application.map;
                this.map = map;
                //注册地图单击事件
                this._executeIdentifyTaskHandle = on(map, "tap", lang.hitch(this, this._executeIdentifyTask));
            },

            deactivate: function () {
                var handle = this._executeIdentifyTaskHandle;
                if (handle) {
                    //取消事件注册
                    dojo.disconnect(handle);
                }
            },

            // -----私有方法（下划线 + 小驼峰）-----
            _executeIdentifyTask: function (evt) {
                this.deactivate();

                var me = this;
                var map = me.map;

                var items = [];
                for (var i = 0; i < map.layerIds.length; i++) {
                    var layerId = map.layerIds[i];
                    var layer = map.getLayer(layerId);
                    
                    if (layer && layer.visible) {
                        if (layer.isInstanceOf(ArcGISDynamicMapServiceLayer)) {// 动态图层查询可见
                            var visibleLayers = layer.visibleLayers || [];
                            if (layer.id == 'dynamicLayer') {
                                var dynamicLayerInfos = layer.dynamicLayerInfos;                               
                                for (var j = 1, len = dynamicLayerInfos&&dynamicLayerInfos.length; j < len; j++) {
                                    var item = dynamicLayerInfos[j];
                                    items.push({
                                        url: layer.url,
                                        visibleLayers: visibleLayers,
                                        dynamicLayerInfos: [item],
                                        //type: 'dynamicLayer'
                                    });
                                }
                            } else {
                                items.push({
                                    url: layer.url,
                                    visibleLayers: visibleLayers,
                                    dynamicLayerInfos:[],
                                    //type: 'dmsl'
                                });
                            }
                        }
                    }
                }
                if(items.length<=0){
                    return;
                }
                var result = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    result.push(me._executeOneIdentifyTask(item, evt));
                }
              
                map.infoWindow.setFeatures(result);
                map.infoWindow.show(evt.mapPoint);
            },
            _executeOneIdentifyTask: function (item, evt) {
                var me = this;
                var map = me.map;
                // 识别任务
                var identifyTask = new esri.tasks.IdentifyTask(item.url);
                // 识别任务参数
                var identifyParams = new esri.tasks.IdentifyParameters();
                identifyParams.tolerance = 10;
                identifyParams.returnGeometry = true;
                identifyParams.layerOption = esri.tasks.IdentifyParameters.LAYER_OPTION_ALL;
                //if (item.type == 'dynamicLayer') {
                //    identifyParams.dynamicLayerInfos = item.layers;
                //} else {
                //    identifyParams.layerIds = item.layers;
                //}
                identifyParams.layerIds = item.visibleLayers;
                identifyParams.dynamicLayerInfos = item.dynamicLayerInfos;
                if (item.type == 'dynamicLayer') {
                    
                }
                identifyParams.width = map.width;
                identifyParams.height = map.height;
                identifyParams.geometry = evt.mapPoint;
                identifyParams.mapExtent = map.extent;

                var deferred = identifyTask.execute(identifyParams);
                deferred.addCallback(function (response) {
                    return dojo.map(response, function (result) {
                        //console.log(result);
                        var feature = result.feature;
                        var attributes = feature.attributes;
                        var content = "<div style='float:left;width:210px;'>";
                        for (var key in attributes) {
                            // 过滤属性
                            var lowerKey = key.toLowerCase();
                            if (lowerKey.indexOf(".sde.") > 0) {
                                continue;
                            }
                            var filterArr = ["object", "shape", "fid", "id", "objectid", "objectid_1"];
                            if (me._indexOf(filterArr, lowerKey) < 0) {
                                var value = attributes[key] || "";
                                // 过滤值
                                var upperValue = value.toUpperCase();
                                if (upperValue == "NULL") {
                                    value = "";
                                }
                                if (lang.trim(value) == "") {
                                    value = "<空>";
                                }
                                if (key == "详细信息") {
                                    value = "<a href=" + value + " target=_blank>" + "点击查看" + "</a>";
                                }
                                content += "<span>" + key + "：</span><span>" + value + "</span><br/>";
                            }
                        }
                        content += "</div>";
                        var template = new esri.InfoTemplate("详情", content);
                        feature.setInfoTemplate(template);
                        return feature;
                    });
                });

                return deferred;                
            },
            // 查找元素在数组中是否存在
            _indexOf: function (arr, element) {
                var result = -1;
                for (var i = 0; i < arr.length; i++) {
                    if (arr[i] == element) {
                        result = i;
                        break;
                    }
                }
                return result;
            }
        };

        func.init();

        return func;
    });
