define([], function() {

    var tool = {
        map: config.map,

        init : function() {

        },
        onClick: function (nodes) {
            var me = this;
            me.getCheckedNodes(nodes);

        },
        getCheckedNodes: function (nodes) {
            dojo.require("esri/layers/DynamicLayerInfo");
            dojo.require("esri/layers/LayerDataSource");
            dojo.require("esri/layers/LayerDrawingOptions");
            dojo.require("esri/layers/TableDataSource");
            dojo.require("esri/layers/RasterDataSource");
            dojo.require("esri/renderers/SimpleRenderer");
            dojo.require("esri/symbols/SimpleFillSymbol");
            dojo.require("esri/symbols/SimpleLineSymbol");
            dojo.require("esri/symbols/SimpleMarkerSymbol");
            dojo.require("esri/Color");
            dojo.require("esri/renderers/UniqueValueRenderer");
            dojo.require("esri/renderers/ClassBreaksRenderer");
            //dojo.require("esri/layers/ArcGISDynamicMapServiceLayer");

            var me = this;
            var map = me.map;
            //var nodes = treeObj.getCheckedNodes(true);
            for (var i = 0; i < map.layerIds.length; i++) {
                var layerId = map.layerIds[i];
                var layer = map.getLayer(layerId);
                if (layer.layerFlag == 'symbol_config_true') {
                    map.removeLayer(layer);
                    i--;
                }
            }

            //console.log(nodes);
            var nodesObj = {
                point: [],
                polyline: [],
                polygon: [],
                rasterData: []
            };
            for (var index in nodes) {
                if (nodes[index].layer_type == "Point") {
                    nodesObj.point.push(nodes[index]);
                } else if (nodes[index].layer_type == "Polyline") {
                    nodesObj.polyline.push(nodes[index]);

                } else if (nodes[index].layer_type == "Polygon") {
                    nodesObj.polygon.push(nodes[index]);
                } else if (nodes[index].layer_type == "RasterDataset") {
                    nodesObj.rasterData.push(nodes[index]);
                }
            }

            nodes = [].concat(nodesObj.point, nodesObj.polyline, nodesObj.polygon, nodesObj.rasterData);
            var dynamicLayerInfos = map.getLayer("dynamicLayer").createDynamicLayerInfosFromLayerInfos();

            var options = [, ];
            for (var index in nodes) {
                var treeNode = nodes[index];
                if (treeNode.symbol_config != 'true') {
                    me.addDynamicLayer(nodes[index], dynamicLayerInfos, options);
                }
            }
            map.getLayer("dynamicLayer").setDynamicLayerInfos(dynamicLayerInfos, true);
            map.getLayer("dynamicLayer").setLayerDrawingOptions(options);
            setTimeout(function () {
                map.getLayer("dynamicLayer").refresh();
            }, 500);
            for (var index in nodes) {
                var treeNode = nodes[index];

                if (treeNode.symbol_config == 'true') {
                    var mapServerUrl = config.url.hostUrl + ':6080/arcgis/rest/services/' + config.url.workspaceId + '/' + treeNode.layer_id + '/MapServer';
                    var dmsl = new esri.layers.ArcGISDynamicMapServiceLayer(mapServerUrl);
                    dmsl.layerFlag = 'symbol_config_true';
                    if (treeNode.layer_type == 'Point' || treeNode.layer_type == 'Polyline') {
                        map.addLayer(dmsl, map.layerIds.length);

                    } else if (treeNode.layer_type == 'Polygon' || treeNode.layer_type == 'RasterDataset') {
                        map.addLayer(dmsl, map.layerIds.indexOf("dynamicLayer"));
                    }
                    setTimeout(function () {
                        dmsl.refresh();
                    }, 500);
                }
            }
            //sidebar.hideLoading(me.id);

        },
        addDynamicLayer: function (treeNode, dynamicLayerInfos, options) {
            var me = this;
            var map = me.map;

            var dataSource, layerSource, drawingOptions;
            var dynamicLayerInfo = new esri.layers.DynamicLayerInfo();
            //这里的id不能为0，否则会覆盖掉默认图层
            dynamicLayerInfo.id = dynamicLayerInfos.length;
            dynamicLayerInfo.name = treeNode.layer_id;
            dynamicLayerInfo.layer_type = treeNode.layer_type;

            //判断图层类型
            if (treeNode.layer_type == "RasterDataset") { //栅格数据不需要渲染render，只需这样就可以正常显示了
                dataSource = new esri.layers.RasterDataSource();
                dataSource.workspaceId = config.url.workspaceId;
                dataSource.dataSourceName = treeNode.layer_id;

            } else {
                dataSource = new esri.layers.TableDataSource();
                dataSource.workspaceId = config.url.workspaceId;
                dataSource.dataSourceName = treeNode.layer_id;
            }
            layerSource = new esri.layers.LayerDataSource();
            layerSource.dataSource = dataSource;
            dynamicLayerInfo.source = layerSource;
            dynamicLayerInfos.push(dynamicLayerInfo);

            drawingOptions = new esri.layers.LayerDrawingOptions();

            if (treeNode.layer_type == "RasterDataset") {//栅格类型图层
                drawingOptions.renderer = null;
            }
            if (treeNode.layer_type == "Point") {
                drawingOptions.renderer = new esri.renderer.SimpleRenderer(
                     new esri.symbol.SimpleMarkerSymbol({
                         "color": [0, 130, 87, 255],
                         "size": 8,
                         "type": "esriSMS",
                         "style": "esriSMSCircle",
                         "outline": {
                             "color": [0, 0, 0, 255],
                             "width": 1,
                             "type": "esriSLS",
                             "style": "esriSLSSolid"
                         }
                     }));
            } else if (treeNode.layer_type == "Polyline") {
                drawingOptions.renderer = new esri.renderer.SimpleRenderer(
                    new esri.symbol.SimpleLineSymbol(
                    esri.symbol.SimpleLineSymbol.STYLE_SOLID, new esri.Color([48, 127, 105, 1]), 1.5));

            } else if (treeNode.layer_type == "Polygon") {
                drawingOptions.renderer = new esri.renderer.SimpleRenderer(
                     new esri.symbol.SimpleFillSymbol("solid",
                     new esri.symbol.SimpleLineSymbol("solid", new dojo.Color([110, 110, 110, 1]), 0.4),
                     new dojo.Color([199, 234, 254, 1])
                ));
            }
            options.push(drawingOptions);

        }
	};

	tool.init();

	return tool;
});
