﻿angular.module('starter', ['ionic', 'starter.controllers', 'starter.config', 'starter.services', 'starter.directive', 'ngResource', 'ngCordova'])
    .run(function ($ionicPlatform, $location, $ionicHistory, $ionicPopup, $ionicLoading, $cordovaAppVersion,
        $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
				
				navigator.splashscreen.hide(); 

            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
            }
            window.alert = function (msg) {
                $ionicPopup.alert({
                    title: '信息提示',
                    template:msg,
                    buttons: [
                       {
                           text: '确定',
                           type: 'button-positive'
                       }
                    ]
                }).then(function (res) {

                });
            };
            window.confirm = function (obj) {
                $ionicPopup.confirm({
                    title: '<strong>信息提示</strong>',
                    template: obj.msg,
                    okText: '确定',
                    cancelText: '取消'
                }).then(function (res) {
                    if (res) {
                        if (obj.refresh) {
                            $timeout(function () {
                                obj.okFn();
                            }, 200);
                        } else {
                            setTimeout(function () {
                                obj.okFn();
                            }, 200);
                        }
                    }
                });

            };
            window.showLoading = function () {
                $ionicLoading.show({
                    content: 'Loading',
                    animation: 'fade-in',
                    showBackdrop: true,
                    maxWidth: 200,
                    showDelay: 0
                });
            };
            window.hideLoading = function () {

                $ionicLoading.hide();
            };
            
            //var upgrade = {
            //    init: function () {
            //        var me = this;
            //        var upgradeUrl = config.url.soilWeb + "/UpgradeApp/Query";
            //        $.ajax({
            //            url: upgradeUrl,
            //            type: "GET",
            //            cache: false,//不缓存
            //            dataType: "json",
            //            data: {
            //                //version: $scope.appVersion
            //            },
            //            success: function (result) {
            //                var serverAppVersion = result.version;
            //                $cordovaAppVersion.getVersionNumber().then(function (version) {
            //                    if (parseFloat(serverAppVersion) > parseFloat(version)) {
            //                        $ionicPopup.alert({
            //                            title: '信息提示',
            //                            template: '有新版本V' + serverAppVersion + '，请您更新。',
            //                            okText: "确定"
            //                        }).then(function (res) {
            //                            var u = navigator.userAgent;
            //                            var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; //android终端
            //                            var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
            //                            if (isiOS) {
            //                                me.upgradeIOS();

            //                            } else if (isAndroid) {
            //                                me.upgradeAndroid();
            //                            } else {
            //                                window.alert("未知您的操作系统平台。");
            //                            }

            //                        });
            //                    }
            //                });
            //            },
            //            error: function (xhr, errorType, error) {
            //                //$ionicLoading.hide();
            //                console.log(error);
            //            }
            //        });
            //    },
            //    upgradeIOS: function (version) {
            //        var appUrl = "https://itunes.apple.com/cn/app/guo-jia-tu-rang-xin-xi/id1191773748?mt=8";
            //        cordova.InAppBrowser.open(appUrl, '_system', 'location=yes');

            //    },
            //    upgradeAndroid: function () {
            //        $ionicLoading.show({
            //            template: "已经下载：0%"
            //        });
            //        var appUrl = config.url.hostUrl + "/map/mobile/app/android.apk?timestamp=" + new Date().getTime();
            //        var targetPath = "file:///mnt/sdcard/Download/android.apk";
            //        var trustHosts = true
            //        var options = {};
            //        $cordovaFileTransfer.download(appUrl, targetPath, options, trustHosts)
            //        .then(function (result) {
            //            $cordovaFileOpener2.open(
            //                targetPath, 'application/vnd.android.package-archive'
            //            ).then(function () {
            //            }, function (err) {
            //            });
            //            $ionicLoading.hide();
            //        }, function (err) {
            //            alert('下载失败');
            //            $ionicLoading.hide();
            //        }, function (progress) {
            //            $timeout(function () {
            //                var downloadProgress = (progress.loaded / progress.total) * 100;
            //                $ionicLoading.show({
            //                    template: "已经下载：" + Math.floor(downloadProgress) + "%"
            //                });
            //                if (downloadProgress > 99) {
            //                    $ionicLoading.hide();
            //                }
            //            });
            //        });

            //    }
            //};
            //版本更新 
            //if (window.cordova && window.cordova.plugins && $cordovaAppVersion) {
            //    upgrade.init();
            //}

            $ionicPlatform.registerBackButtonAction(function (e) {
                e.preventDefault();
                var path = $location.path();
                if (path == '/tab/user' || path == '/tab/map' || path == '/tab/list' || path == '/tab/identify') {
                    window.confirm({
                        msg: "确定要退出应用吗？",
                        okFn: function () {
                            ionic.Platform.exitApp();
                        }
                    });
                } else if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                    
                } else {
                    window.confirm({
                        msg: "确定要退出应用吗？",
                        okFn: function () {
                            ionic.Platform.exitApp();
                        }
                    });
                }
                return false;
            }, 101);


        });
    })

    .config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider) {


        $ionicConfigProvider.platform.ios.tabs.style('standard');
        $ionicConfigProvider.platform.ios.tabs.position('bottom');
        $ionicConfigProvider.platform.android.tabs.style('standard');
        $ionicConfigProvider.platform.android.tabs.position('standard');

        $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
        $ionicConfigProvider.platform.android.navBar.alignTitle('center');

        $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
        $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

        $ionicConfigProvider.platform.ios.views.transition('ios');
        $ionicConfigProvider.platform.android.views.transition('android');

        $stateProvider

            // setup an abstract state for the tabs directive
            .state('tab', {
                url: "/tab",
                abstract: true,
                templateUrl: "templates/tabs.html",
                controller: 'AppCtrl'
            })
            .state('tab.map', {
                url: '/map',
                views: {
                    'tab-map': {
                        templateUrl: 'templates/map/map.html',
                        controller: 'MapCtrl'
                    }
                }
            })
            .state('tab.queryLayer', {
                url: '/queryLayer/:id/:name',
                //cache: false,//禁止缓存
                views: {
                    'tab-map': {
                        templateUrl: 'templates/map/queryLayer.html',
                        controller: 'QueryLayerCtrl'
                    }
                }
            })
            .state('tab.detailInfo', {
                url: '/detailInfo/?url=',
                views: {
                    'tab-map': {
                        templateUrl: 'templates/map/detailInfo.html',
                        controller: 'DetailInfoCtrl'
                    }
                }
            })
            .state('tab.identify', {
                url: '/identify',
                //cache: false,//禁止缓存
                views: {
                    'tab-identify': {
                        templateUrl: 'templates/soil/identify.html',
                        controller: 'IdentifyCtrl'
                    }
                }
            })
            .state('tab.soil_identify_list', {
                url: '/soil_identify_list',
                cache: false,//禁止缓存
                views: {
                    'tab-user': {
                        templateUrl: 'templates/soil/soil_identify_list.html',
                        controller: 'SoilIdentifyListCtrl'
                    }
                }
            })          
            .state('tab.soil_identify', {
                url: '/soil_identify/:task/:id',
                cache: false,//禁止缓存
                views: {
                    'tab-user': {
                        templateUrl: 'templates/soil/soil_identify.html',
                        controller: 'SoilIdentifyCtrl'
                    }
                }
            })
            .state('tab.tool', {
                url: '/tool',
                cache: false,//禁止缓存
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/soil_tool.html',
                        controller: 'SoilToolCtrl'
                    }
                }
            })
            .state('tab.sampling', {
                url: '/sampling',
                cache: false,//禁止缓存
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/project_list.html',
                        controller: 'ProjectListCtrl'
                    }
                }
            })
            .state('tab.project_content', {
                url: '/project_content/:task/:id',
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/project_content.html',
                        controller: 'ProjectContentCtrl'
                    }
                }

            })
            .state('tab.point_list', {
                url: '/point_list/:projectId',
                cache: false,//禁止缓存
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/point_list.html',
                        controller: 'PointListCtrl'
                    }
                }

            })
            .state('tab.point_content', {
                url: '/point_content/:task/:projectId/:id',
                //cache: false,//禁止缓存
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/point_content.html',
                        controller: 'PointContentCtrl'
                    }
                }

            })
            .state('tab.polygon_list', {
                url: '/polygon_list/:pointId',
                cache: false,//禁止缓存
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/polygon_list.html',
                        controller: 'PolygonListCtrl'
                    }
                }

            })
            .state('tab.polygon_content', {
                url: '/polygon_content/:task/:pointId/:id',
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/polygon_content.html',
                        controller: 'PolygonContentCtrl'
                    }
                }

            })
            .state('tab.reference_degree_list', {
                url: '/reference_degree_list',
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/tool/reference_degree_list.html',
                        controller: 'ReferenceDegreeListCtrl'
                    }
                }
            })
            .state('tab.reference_degree_content', {
                url: '/reference_degree_content/:taskType',
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/tool/reference_degree_content.html',
                        controller: 'ReferenceDegreeContentCtrl'
                    }
                }
            })
            .state('tab.texture_separate', {
                url: '/texture_separate',             
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/tool/texture_separate.html',
                        controller: 'TextureSeparateCtrl'
                    }
                }
            })
            .state('tab.matter_carbon', {
                url: '/matter_carbon',
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/tool/matter_carbon.html',
                        controller: 'MatterCarbonCtrl'
                    }
                }
            })
            .state('tab.percentage_content', {
                url: '/percentage_content',
                views: {
                    'tab-tool': {
                        templateUrl: 'templates/soil/tool/percentage_content.html',
                        controller: 'PercentageContentCtrl'
                    }
                }
            })
            .state('tab.user', {
                 url: '/user',
                 //cache: false,//禁止缓存
                 views: {
                     'tab-user': {
                         templateUrl: "templates/user/user.html",
                         controller: 'UserCtrl'
                     }
                 }

             })
            .state('tab.personal', {
                url: '/personal',
                views: {
                    'tab-user': {
                        templateUrl: "templates/user/personal.html",
                        controller: 'PersonalCtrl'
                    }
                }

            })
            .state('tab.advice', {
                url: '/advice',
                views: {
                    'tab-user': {
                        templateUrl: "templates/user/advice.html",
                        controller: 'AdviceCtrl'
                    }
                }

            })
            .state('tab.adviceItem', {
                url: '/adviceItem/:id/:title/:is_handler',
                views: {
                    'tab-user': {
                        templateUrl: "templates/user/adviceItem.html",
                        controller: 'AdviceItemCtrl'
                    }
                }

            })
            .state('tab.login', {
                url: '/login',
                views: {
                    'tab-user': {
                        templateUrl: "templates/user/login.html",
                        controller: 'LoginCtrl'
                    }
                }
            })
            .state('tab.register', {
                url: '/register/:type',
                views: {
                    'tab-user': {
                        templateUrl: "templates/user/register.html",
                        controller: 'RegisterCtrl'
                    }
                }
            })
          
        // if none of the above states are matched, use this as the fallback
        
        $urlRouterProvider.otherwise('/tab/map');
        

    });
